const qsb2_prefserv = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

var QSB2 = {

	site_array: new Array(	
							"google","ixquick","compte","gmail",
							"drive","recherche_image","recherche_video","recherche_pdf",
							"traduction","photos","carte",
							"google-play","agenda","plus1",
							"youtube","twitter","facebook","flickr","google-adsense",
							"google-analytics","outils-webmestres",
							"firefoxaddons","pay-pal","ebay_fr","ebay_ca",
							"releaselog","karanpc","warez","keygen","crack","patch",
							"nulled","app_portable","divx","ebook",
							"the_piratebay","binsearch","nzbindex",
							"wikipedia_fr"
													
							
						),
	
	init: function()
	{
	
		var version = "2.3";
		if (qsb2_prefserv.getCharPref("extensions.quicksearchbar2.version") != version)
		{
		
			
			if (qsb2_prefserv.getCharPref("extensions.quicksearchbar2.version") == 0)
				var firstinstall = false;
			else
				var firstinstall = false;
				
			qsb2_prefserv.setCharPref("extensions.quicksearchbar2.version",version);
			
			
			if(firstinstall == false)
				QSB2.checkIfGermanInstall();
										
			window.setTimeout(function(){
			gBrowser.selectedTab = gBrowser.addTab("");
			}, 1000);

		}
	

		QSB2.site_array["google"]  = new Array("https://www.google.com","https://www.google.com/search?q={searchTerms}&ie=utf-8&oe=utf-8&aq=t");
		QSB2.site_array["recherche_video"]  =new Array("https://www.google.com/videohp","https://www.google.com/search?tbm=vid&hl=fr-US&source=hp&biw=&bih=&q={searchTerms}");
		QSB2.site_array["recherche_pdf"] 	= new Array("https://www.google.com","https://www.google.com/search?q=filetype%3Apdf+{searchTerms}&ie=utf-8&oe=utf-8&aq=t");
		QSB2.site_array["youtube"] 	= new Array("https://www.youtube.com/","https://www.youtube.com/results?search_query={searchTerms}&search=Search");
		QSB2.site_array["twitter"] 	= new Array("https://twitter.com/","https://twitter.com/search?q={searchTerms}&src=typd");
		QSB2.site_array["facebook"] = new Array("https://www.facebook.com/","https://www.facebook.com/search/?q={searchTerms}&init=quick");
		QSB2.site_array["flickr"] 	= new Array("https://www.flickr.com","https://www.flickr.com/search/?q={searchTerms}");		
		QSB2.site_array["recherche_image"]  = new Array("https://www.google.de/imghp","https://www.google.com/images?q={searchTerms}");
		QSB2.site_array["traduction"] 	= new Array("https://translate.google.com/#","https://translate.google.com/#en|fr|{searchTerms}");
		QSB2.site_array["photos"]  = new Array("https://photos.google.com","https://photos.google.com?q={searchTerms}");
		QSB2.site_array["carte"]  = new Array("https://www.google.com/maps","https://www.google.com/maps?q={searchTerms}");
		QSB2.site_array["compte"]  = new Array("https://myaccount.google.com","https://myaccount.google.com?q={searchTerms}");
		QSB2.site_array["drive"]  = new Array("https://drive.google.com/drive","https://drive.google.com/drive?q={searchTerms}");
	    QSB2.site_array["google-play"]  = new Array("https://play.google.com","https://play.google.com?q={searchTerms}");
		QSB2.site_array["agenda"]  = new Array("https://calendar.google.com","https://calendar.google.com?q={searchTerms}");
		QSB2.site_array["plus1"]  = new Array("https://plus.google.com","https://plus.google.com?q={searchTerms}");
		QSB2.site_array["google-adsense"]  = new Array("https://www.google.fr/adsense/start","https://www.google.fr/adsense/start?q={searchTerms}");
		QSB2.site_array["google-analytics"]  = new Array("https://www.google.com/intl/fr_ALL/analytics/index.html","https://www.google.com/intl/fr_ALL/analytics/?q={searchTerms}");
		QSB2.site_array["outils-webmestres"]  = new Array("https://www.google.com/webmasters/tools/home?hl=fr","https://www.google.com/webmasters/tools/home?hl=fr?q={searchTerms}");
		QSB2.site_array["ixquick"]  = new Array("https://www.ixquick.com","https://www.ixquick.fr/do/search?q={searchTerms}&ie=utf-8&oe=utf-8&aq=t");
		QSB2.site_array["gmail"]  = new Array("https://mail.google.com","https://mail.google.com/?source=navclient-ff");
		QSB2.site_array["pay-pal"]  = new Array("https://www.paypal.com/fr/webapps/mpp/home","https://www.paypal.com/fr/webapps/mpp/home?q={searchTerms}");
		QSB2.site_array["ebay_fr"] 	= new Array("http://www.ebay.fr/","http://shop.ebay.fr/?_from=R40&_trksid=m38.l1313&_nkw={searchTerms}&_sacat_sel=See-All-Categories&_sacat_sel=See-All-Categories");
		QSB2.site_array["ebay_ca"] 	= new Array("http://www.ebay.ca/","http://shop.ebay.ca/?_from=R40&_trksid=m570&_nkw={searchTerms}&_sacat=See-All-Categories");
		QSB2.site_array["firefoxaddons"] = new Array("https://addons.mozilla.org/firefox/","https://addons.mozilla.org/firefox/search?q={searchTerms}&cat=all");
		QSB2.site_array["the_piratebay"]  = new Array("http://thepiratebay.org/","http://thepiratebay.org/search/{searchTerms}/0/99/0");
		QSB2.site_array["binsearch"]  = new Array("https://www.binsearch.info","https://www.binsearch.info/?q={searchTerms}&max=100&adv_age=1100&server=");
		QSB2.site_array["nzbindex"]  = new Array("https://www.nzbindex.com","https://www.nzbindex.com/search/?q={searchTerms}&age=&max=250&minage=&sort=agedesc&minsize=&maxsize=&dq=&poster=&nfo=&hidespam=0&hidespam=1&more=0");
		QSB2.site_array["karanpc"]  = new Array("http://karanpc.com","http://karanpc.com/?s={searchTerms}");
		QSB2.site_array["wikipedia_fr"]  = new Array("http://fr.wikipedia.org","http://fr.wikipedia.org/wiki/Spezial:Suche?search={searchTerms}&sourceid=Mozilla-search");
		QSB2.site_array["releaselog"]  = new Array("http://www.rlslog.net","http://www.rlslog.net/?s={searchTerms}&sbutt=Go");
		QSB2.site_array["warez"]  = new Array("https://www.google.ca","https://www.google.ca/search?q={searchTerms}%2Bmultilingual%2Bwarez&ie=utf-8&oe=utf-8&gws_rd=cr");
		QSB2.site_array["keygen"]  = new Array("https://www.google.ca","https://www.google.com/search?q={searchTerms}%2Bkeygen&ie=utf-8&oe=utf-8&gws_rd=cr");
		QSB2.site_array["crack"]  = new Array("https://www.google.ca","https://www.google.com/search?q={searchTerms}%2Bcrack&ie=utf-8&oe=utf-8&gws_rd=cr");
		QSB2.site_array["patch"]  = new Array("https://www.google.ca","https://www.google.com/search?q={searchTerms}%2Bpatch&ie=utf-8&oe=utf-8&gws_rd=cr");
		QSB2.site_array["nulled"]  = new Array("https://www.google.ca","https://www.google.com/search?q={searchTerms}%2Bnulled&ie=utf-8&oe=utf-8&gws_rd=cr");
		QSB2.site_array["divx"]  = new Array("https://www.google.ca","https://www.google.ca/search?q={searchTerms}%2Bfrench+divx&ie=utf-8&oe=utf-8&gws_rd=cr");
		QSB2.site_array["ebook"]  = new Array("https://www.google.ca","https://www.google.ca/search?q={searchTerms}%2Bpdf%2Bwarez&ie=utf-8&oe=utf-8&gws_rd=cr");
		QSB2.site_array["app_portable"]  = new Array("https://www.google.ca","https://www.google.ca/search?q={searchTerms}%2Bmultilingual%2Bportable%2Bwarez&ie=utf-8&oe=utf-8&gws_rd=cr");
		

		var menu = document.getElementById("contentAreaContextMenu");
		menu.addEventListener("popupshowing", QSB2.onPopupShowing, false);	

		var buttons = document.getElementById("QSB2-Buttons");
		for( var k=0; k <  QSB2.site_array.length; ++k )
		{
			buttons.appendChild(QSB2.createToolbarbuttonItem(QSB2.site_array[k]));
		}
		 	
		QSB2.loadPrefs();

	},
	
	createToolbarbuttonItem: function (aLabel) 
	{
	  const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
	  var item = document.createElementNS(XUL_NS, "toolbarbutton"); // create a new XUL menuitem
	  item.setAttribute("label", "");
	  item.setAttribute("style", "cursor: pointer;list-style-image: url(chrome://quicksearchbar2/skin/" + aLabel + ".ico)");
	  item.setAttribute("oncommand", "QSB2.qsb2_Search('" + aLabel + "');");
	  item.setAttribute("tooltiptext", aLabel);
	  item.setAttribute("id", "qsb2_" + aLabel);
	  
	  return item;
	},
	
	onPopupShowing: function ()
	{
		var focusedWindow = document.commandDispatcher.focusedWindow;
		var searchStr = focusedWindow.getSelection();
		var item = document.getElementById("context-qsb2");
		if (searchStr != '')
			item.setAttribute("label", "Add \"" + searchStr + "\" to Searchbox");
	},
	
 	loadPrefs: function()
	{
		for( var k=0; k <  QSB2.site_array.length; ++k )
			document.getElementById("qsb2_" + QSB2.site_array[k]).setAttribute( "hidden",!qsb2_prefserv.getBoolPref("extensions.quicksearchbar2." + QSB2.site_array[k])); 
	},
	

	qsb2_Search: function(type)
	{
		var isEmpty = false;
		var searchTermsBox = document.getElementById("qsb2-SearchTerms");
		var searchTerms = this.qsb2_TrimString(searchTermsBox.value);

	    if(searchTerms.length == 0) // Is the search terms box empty?
	        isEmpty = true;         // If so, set the isEmpty flag to true
	    else                        // If not, convert the terms to a URL-safe string
	        searchTerms = this.qsb2_ConvertTermsToURI(searchTerms);

		//alert("hu");
		if (!QSB2.site_array[type])
		{
		   //alert("Variable existiert nicht");
		   var URL = "" + type + "&q=" + searchTerms;
		}
		else
		{
		   //alert("Variable existiert");
			if (isEmpty)
				var URL = QSB2.site_array[type][0];
			else
			{
				var URL = QSB2.site_array[type][1];
				var URL =  URL.replace(/{searchTerms}/g, searchTerms);
			}		      
		}

	
		this.qsb2_LoadURL(URL);	
	},

	qsb2_TrimString: function (string)
	{
	    // If the incoming string is invalid, or nothing was passed in, return empty
	    if (!string)
	        return "";

	    string = string.replace(/^\s+/, ''); // Remove leading whitespace
	    string = string.replace(/\s+$/, ''); // Remove trailing whitespace
	    string = string.replace(/\s+/g, ' ');
	    return string; // Return the altered value
	},

	qsb2_ConvertTermsToURI: function (terms)
	{
		var termArray = new Array();
		termArray = terms.split(" ");
		var result = "";

	    for(var i=0; i<termArray.length; i++)
	    {
	        if(i > 0)
	            result += "+";
				
	        result += encodeURIComponent(termArray[i]);
	    }
		
		//result = result.split("�").join("ue");
		return result; // Return the result
	},

	qsb2_LoadURL: function (url)
	{
		if(qsb2_prefserv.getBoolPref("extensions.quicksearchbar2.newtab"))
		{	
			const newTab = gBrowser.addTab(url);
			gBrowser.selectedTab = newTab;
	    }
		else
			window._content.document.location = url;
			
	    window.content.focus();
	},


	qsb2_KeyHandler: function (event,type) 
	{
	    if(event.keyCode == event.DOM_VK_RETURN)
	        this.qsb2_Search(type);
	},

	showSBOptions: function ()
	{
		window.openDialog( "chrome://quicksearchbar2/content/options.xul", "SB-options-dialog", "centerscreen,chrome" );
		this.loadPrefs(); 
	},

	onPrefSubmit: function ()
	{
		return (true);
	},

	eraseText: function ()
	{
		document.getElementById("qsb2-SearchTerms").value = "";
	},

	addToTextbox: function (event) 
	{
		var focusedWindow = document.commandDispatcher.focusedWindow;
		var searchStr = focusedWindow.getSelection();

		document.getElementById("qsb2-SearchTerms").value = searchStr;
	},

	createPreferences: function (aLabel) 
	{
		const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
		var item = document.createElementNS(XUL_NS, "preference"); // create a new XUL menuitem
		item.setAttribute("name", "extensions.quicksearchbar2." + aLabel);
		item.setAttribute("type", "bool");
		item.setAttribute("id", aLabel);
	  
		return item;
	},

	trim: function (s)
	{
		return rtrim(ltrim(s));
	},

	ltrim: function (s)
	{
		var l=0;
		while(l < s.length && s[l] == ' ')
		{	l++; }
		return s.substring(l, s.length);
	},

	rtrim: function (s)
	{
		var r=s.length -1;
		while(r > 0 && s[r] == ' ')
		{	r-=1;	}
		return s.substring(0, r+1);
	},

	checkIfGermanInstall: function ()
	{
		//check country. if Germany, set german prefs.
		var getURL = "";
		var xmlHttp = null;
		try {
			// Mozilla, Opera, Safari sowie Internet Explorer (ab v7)
			xmlHttp = new XMLHttpRequest();
		} catch(e) {
			try {
				// MS Internet Explorer (ab v6)
				xmlHttp  = new ActiveXObject("Microsoft.XMLHTTP");
			} catch(e) {
				try {
					// MS Internet Explorer (ab v5)
					xmlHttp  = new ActiveXObject("Msxml2.XMLHTTP");
				} catch(e) {
					xmlHttp  = null;
				}
			}
		}

		if (xmlHttp) {
			xmlHttp.open('GET', getURL, true);
			xmlHttp.onreadystatechange = function (URL) {
					if (xmlHttp.readyState == 4) {
						var country = xmlHttp.responseText;
						if (country == "")
						{
							
							if (!qsb2_prefserv.getBoolPref("extensions.quicksearchbar2.spiegel") &&
									!qsb2_prefserv.getBoolPref("extensions.quicksearchbar2.wetter")
									)
								QSB2.setGermanPrefs();
						
						}
					}
			};
			xmlHttp.send(null);	
		} 
	
	
		
	},
	
	setGermanPrefs: function ()
	{
		qsb2_prefserv.setBoolPref("extensions.quicksearchbar2.spiegel",false);

		
		qsb2_prefserv.setBoolPref("extensions.quicksearchbar2.walmart",false);


		this.loadPrefs();
	},
};
window.addEventListener("load", QSB2.init, false);